package kr.co.mkblog.mkblogopenglesexample;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLES30;
import android.opengl.GLUtils;
import android.util.Log;

public class mkTextureLoader {

    public int textureID[];

    public mkTextureLoader(Context inputContext, String fileName){
        Bitmap textureBitmap;
        BitmapFactory.Options texOption = new BitmapFactory.Options();
        texOption.inScaled = false;
        int inputId = inputContext.getResources().getIdentifier(fileName, "drawable", inputContext.getPackageName());
        if(inputId != 0) {
            textureBitmap = BitmapFactory.decodeResource(inputContext.getResources(), inputId, texOption);
        }
        else{
            Log.d("mkTextureLoader:", "(Error) Loading Texture File to Bitmap");
            return;
        }
        textureID = new int[1];
        GLES30.glGenTextures(1, textureID, 0);
        GLES30.glBindTexture(GLES30.GL_TEXTURE_2D, textureID[0]);
        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_WRAP_S, GLES30.GL_REPEAT);
        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_WRAP_T, GLES30.GL_REPEAT);

        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_MIN_FILTER, GLES30.GL_LINEAR);
        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_MAG_FILTER, GLES30.GL_LINEAR);
        GLUtils.texImage2D(GLES30.GL_TEXTURE_2D, 0, textureBitmap, 0);
        GLES30.glGenerateMipmap(GLES30.GL_TEXTURE_2D);
        Log.d("mkTextureLoader:", "(Good) Ready to use texture");
    }
}
